//---------------------------------------------------------------------------

#include <vcl.h>
#include <IniFiles.hpp>
#include <IOUtils.hpp>
#pragma hdrstop

#include <windows.h>

#include "MainFrm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
const _TCHAR TMainForm::APP_NAME[] = _T("Display Off Soft");
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
    this->m_isHookSet = false;
    this->m_firstTime = true;
    this->m_currentTimer = 0;

    //-----
    // INI t@C֘A
    TIniFile *iniFile = 0;
    try
    {
        iniFile = new TIniFile(this->GetIniFileName());
        this->MaxSecondUpDown->Position
            = iniFile->ReadInteger(_T("SETTINGS"), _T("MAXSECOND"), 600);
        delete iniFile;
    }
    catch(...)
    {
        delete iniFile;
        throw;
    }

    //-----
    // ^XNgCɓo^
    NOTIFYICONDATA  icn;
    icn.cbSize = sizeof(NOTIFYICONDATA);
    icn.hWnd = this->Handle;
    icn.uID = 100;
    icn.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
    icn.uCallbackMessage = WM_MY_TASKTRAY;
    icn.hIcon = Application->Icon->Handle;
    ::lstrcpy(icn.szTip, this->APP_NAME);
    ::Shell_NotifyIcon( NIM_ADD, &icn );

    //-----
    // O[oEtbN֘A
    // DLL̓ǂݍ
    this->m_hInst = ::LoadLibrary(_T("DOSHook.dll"));
    // G[
    if (this->m_hInst == 0)
    {
        ShowMessage(_T("DOSHook.dll: Ǎs܂B"));
        return;
    }

    // DLL֐̃AhX擾
    this->HookStart = (DWORD __stdcall (*)(HWND, const _TCHAR *))::GetProcAddress(this->m_hInst, "HookStart");
    this->HookStop  = (DWORD __stdcall (*)(void))::GetProcAddress(this->m_hInst, "HookStop");

    // G[
    if (this->HookStart == 0 || this->HookStop == 0)
    {
        ShowMessage(_T("DLL ֐̃AhX擾Ɏs܂B"));
        ::FreeLibrary(this->m_hInst);   // ǂݍDLL
        this->m_hInst = 0;
        return;
    }

    // Ot@Cݒ
    this->m_logFileName = this->GetLogFileName();

    // ȂxŃtbNȂƂ̂łĂ݂B
    this->SetHook();
    ::Sleep(0);
    this->UnsetHook();
    ::Sleep(0);
    this->SetHook();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
    //-----
    // ^XNgC珜
    NOTIFYICONDATA  icn;
    icn.cbSize = sizeof(NOTIFYICONDATA);
    icn.hWnd = this->Handle;
    icn.uID = 100;
    icn.uFlags = 0;
    ::Shell_NotifyIcon(NIM_DELETE, &icn);

    //-----
    // O[oEtbN֘A
    this->UnsetHook();
}
//---------------------------------------------------------------------------
// EBhETCYύXMp
void __fastcall TMainForm::WM_GetMinMaxInfo(TWMGetMinMaxInfo &Msg)
{
    const int clientWidth  = 162;
    const int clientHeight = 230;
    const int titleBarHeight = ::GetSystemMetrics(SM_CYCAPTION);

    //ŏTCY
    Msg.MinMaxInfo->ptMinTrackSize.x= clientWidth;
    Msg.MinMaxInfo->ptMinTrackSize.y= clientHeight + titleBarHeight;
    //őTCY
    Msg.MinMaxInfo->ptMaxTrackSize.x= clientWidth;
    Msg.MinMaxInfo->ptMaxTrackSize.y= clientHeight + titleBarHeight;
    //ő剻Ƃ̃TCY
    Msg.MinMaxInfo->ptMaxSize.x= clientWidth;
    Msg.MinMaxInfo->ptMaxSize.y= clientHeight + titleBarHeight;
}
//---------------------------------------------------------------------------
// ő剻Eŏ
void __fastcall TMainForm::WM_SysCommand(TWMSysCommand Msg)
{
    if(Msg.CmdType == SC_MINIMIZE)
    {
        this->Hide();
    }
    else if(Msg.CmdType == SC_MAXIMIZE)
    {
        // doNothing();
    }
    else if(Msg.CmdType == SC_CLOSE)
    {
        this->Hide();
    }
    else
    {
        TForm::Dispatch(&Msg);
    }
}
//---------------------------------------------------------------------------
void TMainForm::SetHook()
{
    //-----
    // O[oEtbN֘A
    if(!this->m_isHookSet)
    {
        this->HookStart(this->Handle, this->m_logFileName.w_str());   // tbNJn
        this->m_isHookSet = true;
    }
}
//---------------------------------------------------------------------------
void TMainForm::UnsetHook()
{
    //-----
    // O[oEtbN֘A
    if(this->m_isHookSet)
    {
        try
        {
            this->HookStop();         // tbN~
            this->m_isHookSet = false;
        }
        catch(EAccessViolation &e)
        {
            return;
        }
    }
}
//---------------------------------------------------------------------------
UnicodeString TMainForm::GetIniFileName() const
{
    return ChangeFileExt(Application->ExeName, _T(".INI"));
}
//---------------------------------------------------------------------------
UnicodeString TMainForm::GetLogFileName() const
{
    return TPath::Combine(ExtractFilePath(Application->ExeName), _T("LOG.txt"));
}
//---------------------------------------------------------------------------
void TMainForm::WriteToIniFile()
{
    TIniFile *iniFile = 0;
    try
    {
        iniFile = new TIniFile(this->GetIniFileName());
        iniFile->WriteInteger(_T("SETTINGS"), _T("MAXSECOND"), this->MaxSecondUpDown->Position);
        delete iniFile;
    }
    catch(...)
    {
        delete iniFile;
        throw;
    }
}
//---------------------------------------------------------------------------
int TMainForm::StrToInt(UnicodeString s)
{
    UnicodeString n;

    for(int i = 1 ; i <= s.Length() ; ++i)
    {
        if(s[i] == _TCHAR('0') ||
           s[i] == _TCHAR('1') ||
           s[i] == _TCHAR('2') ||
           s[i] == _TCHAR('3') ||
           s[i] == _TCHAR('4') ||
           s[i] == _TCHAR('5') ||
           s[i] == _TCHAR('6') ||
           s[i] == _TCHAR('7') ||
           s[i] == _TCHAR('8') ||
           s[i] == _TCHAR('9'))
        {
            n += s[i];
        }
    }

    if(n.Length() == 0)
    {
        return 0;
    }
    else
    {
        return n.ToInt();
    }
}
//---------------------------------------------------------------------------
void TMainForm::ScreenOff()
{
    ::PostMessage(HWND_BROADCAST, WM_SYSCOMMAND, SC_MONITORPOWER, 1);
    ::Sleep(10);
    ::PostMessage(HWND_BROADCAST, WM_SYSCOMMAND, SC_MONITORPOWER, 2);
}
//---------------------------------------------------------------------------
// }EX_EMp
void __fastcall TMainForm::WM_LButtonDown(TMessage Msg)
{
    this->m_currentTimer = -1;
}
//---------------------------------------------------------------------------
// }EX_EMp
void __fastcall TMainForm::WM_MButtonDown(TMessage Msg)
{
    this->m_currentTimer = -1;
}
//---------------------------------------------------------------------------
// E}EX_EMp
void __fastcall TMainForm::WM_RButtonDown(TMessage Msg)
{
    this->m_currentTimer = -1;
}
//---------------------------------------------------------------------------
// }EXړMp
void __fastcall TMainForm::WM_MouseMove(TMessage Msg)
{
    TPoint currentCursorPos;
    currentCursorPos.x = Msg.WParam;
    currentCursorPos.y = Msg.LParam;
    if(this->m_firstTime)
    {
        this->m_cursorPos = currentCursorPos;
        this->m_firstTime = false;
    }
    else
    {
        if(this->m_cursorPos != currentCursorPos)
        {
            this->m_currentTimer = -1;
            this->m_cursorPos = currentCursorPos;
        }
    }
}
//---------------------------------------------------------------------------
// L[{[h͌op
void __fastcall TMainForm::WM_KeyDown(TMessage Msg)
{
    this->m_currentTimer = -1;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Timer1Timer(TObject *Sender)
{
/*
    // }EXEJ[\̈ʒu̕ω
    TPoint currentCursorPos;
    ::GetCursorPos(&currentCursorPos);
    if(this->m_firstTime)
    {
        this->m_cursorPos = currentCursorPos;
        this->m_firstTime = false;
    }
    else
    {
        if(this->m_cursorPos != currentCursorPos)
        {
            this->m_currentTimer = -1;
            this->m_cursorPos = currentCursorPos;
        }
    }
*/

    ++this->m_currentTimer;
    if(this->m_currentTimer >= this->MaxSecondUpDown->Position)
    {
        this->ScreenOff();
        this->m_currentTimer = 0;
    }

    this->SecondLabel->Caption = this->m_currentTimer;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Timer2Timer(TObject *Sender)
{
    if(this->m_isHookSet)
    {
        this->UnsetHook();
        this->SetHook();
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::MaxSecondEditChange(TObject *Sender)
{
    this->WriteToIniFile();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::MaxSecondUpDownChangingEx(TObject *Sender, bool &AllowChange, short NewValue,
          TUpDownDirection Direction)
{
    this->WriteToIniFile();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::MaxSecondEditExit(TObject *Sender)
{
    const int min = this->MaxSecondUpDown->Min;
    const int max = this->MaxSecondUpDown->Max;

    if(this->StrToInt(this->MaxSecondEdit->Text) < min)
    {
        this->MaxSecondUpDown->Position = min;
    }
    else if(this->StrToInt(this->MaxSecondEdit->Text) > max)
    {
        this->MaxSecondUpDown->Position = max;
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::MaxSecondEditKeyPress(TObject *Sender, wchar_t &Key)
{
    if(Key == _TCHAR('0') ||
       Key == _TCHAR('1') ||
       Key == _TCHAR('2') ||
       Key == _TCHAR('3') ||
       Key == _TCHAR('4') ||
       Key == _TCHAR('5') ||
       Key == _TCHAR('6') ||
       Key == _TCHAR('7') ||
       Key == _TCHAR('8') ||
       Key == _TCHAR('9') ||
       Key == VK_BACK)
    {
        // doNothing();
    }
    else
    {
        Key = 0;
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::TrayEvent(TMessage& Msg)
{
    if(Msg.LParam == WM_LBUTTONDOWN)
    {
        this->Show();
    }
    if(Msg.LParam == WM_RBUTTONDOWN)
    {
        POINT p;
        ::GetCursorPos(&p);
        ::SetForegroundWindow(this->Handle);
        this->PopupMenu1->Popup(p.x, p.y);
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ShowItemClick(TObject *Sender)
{
    this->Show();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::MinimizeItemClick(TObject *Sender)
{
    this->Hide();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ExitItemClick(TObject *Sender)
{
    this->Close();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::MinimizeButtonClick(TObject *Sender)
{
    this->Hide();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::StartStopButtonClick(TObject *Sender)
{
    const UnicodeString startCaption = _T("Jn(&S)");
    const UnicodeString stopCaption  = _T("~(&P)");

    if(this->StartStopButton->Caption == startCaption)
    {
        // Jn
        this->MaxSecondEdit->Enabled = false;
        this->MaxSecondUpDown->Enabled = false;
        this->Timer1->Enabled = true;
        this->SetHook();
        this->StartStopButton->Caption = stopCaption;
    }
    else if(this->StartStopButton->Caption == stopCaption)
    {
        // ~
        this->MaxSecondEdit->Enabled = true;
        this->MaxSecondUpDown->Enabled = true;
        this->Timer1->Enabled = false;
        this->UnsetHook();
        this->StartStopButton->Caption = startCaption;
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ExitButtonClick(TObject *Sender)
{
    this->Close();
}
//---------------------------------------------------------------------------

